﻿// migration from java to .NET by SimpleDB# group, 
// http://cs.tju.edu.cn/faculty/zhangkl/projects/simpledbsharp/index.htm

using simpledb.file;

namespace simpledb.buffer
{
    /// <summary>
    /// An interface used to initialize a new block on disk.
    /// There will be an implementing class for each "type" of
    /// disk block.
    /// </summary>
    /// <author>Edward Sciore</author>
    public interface PageFormatter
    {
        /// <summary>
        /// Initializes a page, whose contents will be
        /// written to a new disk block.
        /// This method is called only during the method
        /// <see cref="Buffer.assignToNew"/>.
        /// </summary>
        /// <param name="p">a buffer page</param>
        void format(Page p);
    }
}
