﻿// migration from java to .NET by SimpleDB# group, 
// http://cs.tju.edu.cn/faculty/zhangkl/projects/simpledbsharp/index.htm

using simpledb.query;

namespace simpledb.index.btree
{
    /// <summary>
    /// A directory entry has two components: the number of the child block,
    /// and the dataval of the first record in that block.
    /// <author>Edward Sciore</author> 
    /// </summary>
    public class DirEntry
    {
        private Constant dataval;
        private int blocknum;

        /// <summary>
        /// Creates a new entry for the specified dataval and block number
        /// </summary>
        /// <param name="dataval">the dataval</param>
        /// <param name="blocknum">the block number</param>
        public DirEntry(Constant dataval, int blocknum)
        {
            this.dataval = dataval;
            this.blocknum = blocknum;
        }

        /// <summary>
        /// Returns the dataval component of the entry
        /// </summary>
        /// <returns>the dataval component of the entry</returns>
        public Constant Dataval()
        {
            return dataval;
        }

        /// <summary>
        /// Returns the block number component of the entry
        /// </summary>
        /// <returns>the block number component of the entry</returns>
        public int blockNumber()
        {
            return blocknum;
        }
    }
}
