﻿// migration from java to .NET by SimpleDB# group, 
// http://cs.tju.edu.cn/faculty/zhangkl/projects/simpledbsharp/index.htm

using System;

namespace simpledb.parse
{
    /// <summary>
    /// A runtime exception indicating that the submitted query
    /// has incorrect syntax.
    /// </summary>
    /// <author>Edward Sciore</author> 
    [Serializable]
    public class BadSyntaxException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BadSyntaxException"/> class.
        /// </summary>
        public BadSyntaxException() { }

        /// <summary>
        /// Initializes a new instance of the <see cref="BadSyntaxException"/> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public BadSyntaxException(string message) : base(message) { }

        /// <summary>
        /// Initializes a new instance of the <see cref="BadSyntaxException"/> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="inner">The inner.</param>
        public BadSyntaxException(string message, Exception inner) : base(message, inner) { }

        /// <summary>
        /// Initializes a new instance of the <see cref="BadSyntaxException"/> class.
        /// </summary>
        /// <param name="info">The <see cref="T:System.Runtime.Serialization.SerializationInfo"/> that holds the serialized object data about the exception being thrown.</param>
        /// <param name="context">The <see cref="T:System.Runtime.Serialization.StreamingContext"/> that contains contextual information about the source or destination.</param>
        /// <exception cref="T:System.ArgumentNullException">
        /// The <paramref name="info"/> parameter is null.
        /// </exception>
        /// <exception cref="T:System.Runtime.Serialization.SerializationException">
        /// The class name is null or <see cref="P:System.Exception.HResult"/> is zero (0).
        /// </exception>
        protected BadSyntaxException(
          System.Runtime.Serialization.SerializationInfo info,
          System.Runtime.Serialization.StreamingContext context)
            : base(info, context) { }
    }
}
