﻿// migration from java to .NET by SimpleDB# group, 
// http://cs.tju.edu.cn/faculty/zhangkl/projects/simpledbsharp/index.htm

namespace simpledb.parse
{
    /// <summary>
    /// Data for the SQL <i>create view</i> statement.
    /// </summary>
    /// <author>Edward Sciore</author>
    public class CreateViewData
    {
        private string viewname;
        private QueryData qrydata;

        /// <summary>
        /// Saves the view name and its definition.
        /// </summary>
        /// <param name="viewname"></param>
        /// <param name="qrydata"></param>
        public CreateViewData(string viewname, QueryData qrydata)
        {
            this.viewname = viewname;
            this.qrydata = qrydata;
        }

        /// <summary>
        /// Returns the name of the new view.
        /// </summary>
        /// <returns>the name of the new view</returns>
        public string viewName()
        {
            return viewname;
        }

        /// <summary>
        /// Returns the definition of the new view.
        /// </summary>
        /// <returns>the definition of the new view</returns>
        public string viewDef()
        {
            return qrydata.ToString();
        }
    }
}
