﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using simpledb.query;
using simpledb.parse;
using simpledb.record;

namespace PlantGen {

    /// <summary>
    /// Stub functions generating the Abstract Syntax Tree.
    /// </summary>
    /// <author>Yujie Liu</author>
    public partial class Syntaxer {

        private void program1 ()
        {
            Result = Slot0;
        }

        private void program2 ()
        {
            Result = Slot0;
        }

        private void program3 ()
        {
            Result = Slot0;
        }

        private void program4 ()
        {
            Result = Slot0;
        }

        private void program5 ()
        {
            Result = Slot0;
        }


        #region select
        private void query1 ()
        {
            Result = new QueryData ((List<string>)Slot1, (List<string>)Slot3, (Predicate)Slot4);
        }

        private void query2 ()
        {
            Result = new QueryData ((List<string>)Slot1, (List<string>)Slot3, new Predicate ());
        }

        private void identifier_list1 ()
        {
            (Slot0 as List<string>).Add ((string)Slot2);
            Result = Slot0;
        }

        private void identifier_list2 ()
        {
            List<string> list = new List<string> ();
            list.Add ((string)Slot0);
            Result = list;
        }

        private void identifier1 ()
        {
            Result = (Slot0 as Token).Text;
        }

        private void integer1 ()
        {
            Result = int.Parse ((Slot0 as Token).Text);
        }

        private void string1 ()
        {
            string str = (Slot0 as Token).Text;
            str = str.Substring (1, str.Length - 2);
            Result = new StringConstant (str);
        }

        private void where_clause1 ()
        {
            Result = Slot1;
        }

        private void predicate1 ()
        {
            (Slot0 as Predicate).conjoinWith (new Predicate ((Term)Slot2));
            Result = Slot0;
        }

        private void predicate2 ()
        {
            Result = new Predicate ((Term)Slot0);
        }

        private void term1 ()
        {
            Result = new Term ((Expression)Slot0, (Expression)Slot2);
        }

        private void expression1 ()
        {
            Result = new FieldNameExpression ((string)Slot0);
        }

        private void expression2 ()
        {
            Result = new ConstantExpression ((Constant)Slot0);
        }

        private void constant1 ()
        {
            Result = Slot0;
        }

        private void constant2 ()
        {
            Result = new IntConstant ((int)Slot0);
        }
        #endregion


        #region modify

        private void insert1 ()
        {
            Result = new InsertData ((string)Slot2, (List<string>)Slot4, (List<Constant>)Slot (8));
        }

        private void constant_list1 ()
        {
            (Slot0 as List<Constant>).Add ((Constant)Slot2);
            Result = Slot0;
        }

        private void constant_list2 ()
        {
            List<Constant> list = new List<Constant> ();
            list.Add ((Constant)Slot0);
            Result = list;
        }

        private void delete1 ()
        {
            Result = new DeleteData ((string)Slot2, (Predicate)Slot3);
        }

        private void delete2 ()
        {
            Result = new DeleteData ((string)Slot2, new Predicate ());
        }

        private void update1 ()
        {
            Result = new ModifyData ((string)Slot1, (string)Slot3, (Expression)Slot5, (Predicate)Slot (6));
        }

        private void update2 ()
        {
            Result = new ModifyData ((string)Slot1, (string)Slot3, (Expression)Slot5, new Predicate ());
        }

        #endregion


        #region create

        private void create1 ()
        {
            Result = Slot0;
        }

        private void create2 ()
        {
            Result = Slot0;
        }

        private void create3 ()
        {
            Result = Slot0;
        }

        private void create_table1 ()
        {
            Schema sch = new Schema ();
            foreach (var item in (List<FieldDef>)Slot4)
                sch.addFiled (item.Name, item.Type, item.Length);

            Result = new CreateTableData ((string)Slot2, sch);
        }

        private void field_def_list1 ()
        {
            (Slot0 as List<FieldDef>).Add ((FieldDef)Slot2);
            Result = Slot0;
        }

        private void field_def_list2 ()
        {
            List<FieldDef> list = new List<FieldDef> ();
            list.Add ((FieldDef)Slot0);
            Result = list;
        }

        private void field_def1 ()
        {
            Result = new FieldDef ((string)Slot0, Schema.INTEGER, 0);
        }

        private void field_def2 ()
        {
            Result = new FieldDef ((string)Slot0, Schema.VARCHAR, (int)Slot3);
        }

        private void create_view1 ()
        {
            Result = new CreateViewData ((string)Slot2, (QueryData)Slot4);
        }

        private void create_index1 ()
        {
            Result = new CreateIndexData ((string)Slot2, (string)Slot4, (string)Slot(6));
        }

        #endregion

        public class FieldDef {
            public string Name;
            public int Type;
            public int Length;
            public FieldDef (string name, int type, int length)
            {
                Name = name; Type = type; Length = length;
            }
        }
    }


}
