using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PlantGen
{
    public interface IScanner
    {
        int Line { get; }
        int Column { get; }
        int Index { get; }
        string Text { get; }
        TokenKind Kind { get; }
        bool MoveNext();
    }

    public class Token {
        public int Line { get; private set; }
        public int Column { get; private set; }
        public string Text { get; private set; }
        public Token (int line, int col, string text) { Line = line; Column = col; Text = text; }
    }

    public enum TokenKind
    {
        KW_SELECT,
        KW_FROM,
        KW_WHERE,
        KW_AND,
        KW_INSERT,
        KW_INTO,
        KW_VALUES,
        KW_DELETE,
        KW_UPDATE,
        KW_SET,
        KW_CREATE,
        KW_TABLE,
        KW_INT,
        KW_VARCHAR,
        KW_VIEW,
        KW_AS,
        KW_INDEX,
        KW_ON,
        IDENTIFIER,
        INTEGER,
        STRING,
        OP_COMMA,
        OP_P_L,
        OP_P_R,
        OP_EQ,
        PLANTENDOFFILE
    }

}

